#include "stringExamples.h"
/* Using strcpy and strncpy */
void exStrcpyStrncpy()
{
    printf("Using strcpy and strncpy\n----------------------------\n");
    char x[] = "Happy Birthday to You"; // initialize char array x
    char y[ 25 ]; // create char array y
    char z[ 15 ]; // create char array z

    /* copy contents of x into y */
    printf( "x = \"%s\"\ny has initially an irrelevant contents; y after strcpy( y, x ) = \"%s\"\n",
            x, strcpy( y, x ) );

    /* copy first 14 characters of x into z. Does not copy null
       character */
    strncpy( z, x, 14 );

    z[ 14 ] = '\0';
    /* terminate string in z */
    printf( "z = \"\"\n%s%s\n", "z after strncpy( z, x, 14 ) is: ", z );

} // end exStrcpyStrncpy



/* Using strcat and strncat */
void exStrcatStrncat()
{
    printf("Using strcat and strncat\n----------------------------\n");
    char s1[ 20 ] = "Happy "; /* initialize char array s1 */
    char s2[] = "New Year ";  /* initialize char array s2 */
    char s3[ 40 ] = "";       /* initialize char array s3 to empty */

    printf( "s1 = %s\ns2 = %s\n", s1, s2 );

    /* concatenate s2 to s1 */
    printf( "strcat( s1, s2 ) = %s\n", strcat( s1, s2 ) );

    /* concatenate first 6 characters of s1 to s3. Place '\0'
       after last character */
    printf( "strncat( s3, s1, 6 ) = %s\n", strncat( s3, s1, 6 ) );

    /* concatenate s1 to s3 */
    printf( "strcat( s3, s1 ) = %s\n", strcat( s3, s1 ) );

} // exStrcatStrnCat

/* Using strcmp and strncmp */
void exStrcmpStrnCmp()
{
    printf("Using strcmp and strncmp\n----------------------------\n");
    const char *s1 = "Happy New Year"; /* initialize char pointer */
    const char *s2 = "Happy New Year"; /* initialize char pointer */
    const char *s3 = "Happy Holidays"; /* initialize char pointer */

    printf("%s%s\n%s%s\n%s%s\n\n%s%2d\n%s%2d\n%s%2d\n\n",
           "s1 = ", s1, "s2 = ", s2, "s3 = ", s3,
           "strcmp(s1, s2) = ", strcmp( s1, s2 ),
           "strcmp(s1, s3) = ", strcmp( s1, s3 ),
           "strcmp(s3, s1) = ", strcmp( s3, s1 ) );

    printf("%s%2d\n%s%2d\n%s%2d\n",
           "strncmp(s1, s3, 6) = ", strncmp( s1, s3, 6 ),
           "strncmp(s1, s3, 7) = ", strncmp( s1, s3, 7 ),
           "strncmp(s3, s1, 7) = ", strncmp( s3, s1, 7 ) );
} // exStrcmpStrnCmp

/* Using strchr */
void exStrchr()
{
    printf("Using strchr\n----------------------------\n");
    const char *string = "This is a test"; /* initialize char pointer */
    char character1 = 'a'; /* initialize character1 */
    char character2 = 'z'; /* initialize character2 */

    printf("string = \"%s\"\ncharacter1 = '%c'\ncharacter2 = '%c'\nstrchr( string, character1 ):\n", string, character1, character2);

    /* if character1 was found in string */
    if ( strchr( string, character1 ) != NULL )
    {
        printf( "\'%c\' was found in \"%s\".\n",
                character1, string );
    } /* end if */
    else   /* if character1 was not found */
    {
        printf( "\'%c\' was not found in \"%s\".\n",
                character1, string );
    } /* end else */

    printf("string = %s\ncharacter1 = 'a'\ncharacter2 = 'z'\nstrchr( string, character2 ):\n", string);
    /* if character2 was found in string */
    if ( strchr( string, character2 ) != NULL )
    {
        printf( "\'%c\' was found in \"%s\".\n",
                character2, string );
    } /* end if */
    else   /* if character2 was not found */
    {
        printf( "\'%c\' was not found in \"%s\".\n",
                character2, string );
    } /* end else */
}

/* Using strcspn */
void exStrcspn()
{
    printf("Using strcspn\n----------------------------\n");
    /* initialize two char pointers */
    const char *string1 = "The value is 3.14159";
    const char *string2 = "1234567890";

    printf( "string1 =\"%s\"\nstring2 = \"%s\"\nThe length of the initial segment of string1 containing no characters from string2, strcspn( string1, string2 ) = %u\n",
            string1, string2, strcspn( string1, string2 ) );

}

/* Using strpbrk */
void exStrpbrk()
{
    printf("Using strpbrk\n----------------------------\n");
    const char *string1 = "This is a test"; /* initialize char pointer */
    const char *string2 = "beware";         /* initialize char pointer */

    printf( "string1 = \"%s\"\nstring2 = \"%s\"\nstrpbrk( string1, string2 ):\n%s\"%s\", '%c' %s \"%s\"\n",
            string1, string2, "Of the characters in ", string2,
            *strpbrk( string1, string2 ),
            "appears earliest in", string1 );
}

/* Using strrchr */
void exStrrchr()
{
    printf("Using strrchr\n----------------------------\n");
    /* initialize char pointer */
    const char *string1 = "A zoo has many animals including zebras";

    int c = 'z';
    /* character to search for */

    printf( "string1 = \"%s\"\nc = %c\nstrrchr( string1, c )\n%s\n%s'%c'%s\"%s\"\n",
            string1, c,
            "The remainder of string1 beginning with the",
            "last occurrence of character ", c,
            " is: ", strrchr( string1, c ) );

}

/* Using strspn */
void exStrspn()
{
    printf("Using strspn\n----------------------------\n");
    /* initialize two char pointers */
    const char *string1 = "The value is 3.14159";
    const char *string2 = "aehi lsTuv";

    printf( "%s%s\n%s%s\n\n%s\n%s%u\n",
            "string1 = ", string1, "string2 = ", string2,
            "The length of the initial segment of string1",
            "containing only characters from string2, strspn( string1, string2 ) = ",
            strspn( string1, string2 ) );
}

/* Using strstr */
void exStrstr()
{
    printf("Using strstr\n----------------------------\n");
    const char *string1 = "abcdefabcdef"; /* string to search */
    const char *string2 = "def"; /* string to search for */

    printf( "%s%s\n%s%s\n\n%s\n%s%s\n",
            "string1 = ", string1, "string2 = ", string2,
            "The remainder of string1 beginning with the",
            "first occurrence of string2, strstr( string1, string2 ) = ",
            strstr( string1, string2 ) );
}

/* Using strtok */
void exStrtok()
{
    printf("Using strtok\n----------------------------\n");
    //* initialize array string */
    char string[] = "This is a sentence with 7 tokens";
    char *tokenPtr; /* create char pointer */

    printf( "The string to be tokenized = \"%s\", delimiters are \" \" (only space)\nThe tokens are:\n", string);

    tokenPtr = strtok( string, " " ); /* begin tokenizing sentence */

    /* continue tokenizing sentence until tokenPtr becomes NULL */
    while ( tokenPtr != NULL )
    {
        printf( "\"%s\"\n", tokenPtr );
        tokenPtr = strtok( NULL, " " ); /* get next token */
    } /* end while */
}
/* Using memcpy */
void exMemcpy()
{
    printf("Using memcpy\n----------------------------\n");
        char s1[ 17 ];                   /* create char array s1 */
        char s2[]  = "Copy this string"; /* initialize char array s2 */

        memcpy( s1, s2, 17 );
        printf( "s1 has initially an irelevant contents\ns2 = \"%s\"\ns1 after memcpy( s1, s2, 17 ) = \"%s\"\n",
               s2, s1 );
}

/* Using memmove */
void exMemmove()
{
    printf("Using memmove\n----------------------------\n");
    char x[] = "Home Sweet Home"; /* initialize char array x */

    printf( "%s\"%s\"\n", "The string in array x before memmove is: ", x );
    printf( "%s\"%s\"\n", "The string in array x after (char *)memmove( x, &x[ 5 ], 10 ): ",
            (char *)memmove( x, &x[ 5 ], 10 ) );
}


/* Using memcmp */
void exMemcmp()
{
    printf("Using memcmp\n----------------------------\n");
    char s1[] = "ABCDEFG"; /* initialize char array s1 */
    char s2[] = "ABCDXYZ"; /* initialize char array s2 */

    printf( "%s%s\n%s%s\n\n%s%2d\n%s%2d\n%s%2d\n",
            "s1 = ", s1, "s2 = ", s2,
            "memcmp( s1, s2, 4 ) = ", memcmp( s1, s2, 4 ),
            "memcmp( s1, s2, 7 ) = ", memcmp( s1, s2, 7 ),
            "memcmp( s2, s1, 7 ) = ", memcmp( s2, s1, 7 ) );

}

/* Using memchr */
void exMemchr()
{
    printf("Using memchr\n----------------------------\n");
    const char *s = "This is a string"; /* initialize char pointer */

    printf( "s = \"%s\"\n%s\'%c\'%s\"%s\"\n", s,
            "The remainder of s starting at character ", 'r',
            " (char *)memchr( s, 'r', 16 ) = ", (char *) memchr( s, 'r', 16 ) );
}


/* Using memset */
void exMemset()
{
    printf("Using memset\n----------------------------\n");
    char string1[ 15 ] = "BBBBBBBBBBBBBB"; /* initialize string1 */

    printf( "string1 = %s\n", string1 );
    printf( "string1 after (char *)memset( string1, 'b', 7 ) = %s\n", (char *)memset( string1, 'b', 7 ) );
}

/* Using strerror */
void exStrerr()
{
    printf("Using strerror\n----------------------------\n");
    printf( "strerror( 3 ) = \"%s\"\n", strerror( 3 ) );
}

/* Using strlen */
void exStrlen()
{
    printf("Using strlen\n----------------------------\n");
    //* initialize 3 char pointers */
    const char *string1 = "abcdefghijklmnopqrstuvwxyz";
    const char *string2 = "four";
    const char *string3 = "Boston";

    printf("%s\"%s\"%s%u\n%s\"%s\"%s%u\n%s\"%s\"%s%u\n",
           "The length of ", string1, " is ", strlen( string1 ),
           "The length of ", string2, " is ", strlen( string2 ),
           "The length of ", string3, " is ", strlen( string3 ) );
}

